/**
    Componente tare-conexe
    Algoritmul Plus-Minus
    Complexitate: O(m + n * n)
*/
#include <fstream>
using namespace std;

ifstream fin("ctc.in");
ofstream fout("ctc.out");

const int N = 1001;
bool a[N][N];
int n, m;
int s[N];  /// marcam nodurile vizitate la Dfs
int p[N];  /// marcam nodurile vizitate la DfsT (pe graful transpus)
int ctc;   /// numarul de comp tare-conexe

void CitesteGraf();
void DeterminaCTC();
void Dfs(int x);
void DfsT(int x);

int main()
{
    CitesteGraf();
    DeterminaCTC();
}

void DeterminaCTC()
{
    for (int x = 1; x <= n; ++x)
        if (!s[x])
        {
            ctc++;
            Dfs(x);
            DfsT(x);

            for (int y = 1; y <= n; ++y)
                if (s[y] == p[y] && s[y] == ctc)
                    fout << y << ' ';
                else
                    if (!s[y] || !p[y])
                        s[y] = p[y] = 0;

            fout << '\n';
        }
}

void Dfs(int x) // O(n*n)
{
    s[x] = ctc;
    for (int y = 1; y <= n; ++y)
    {
        if (!a[x][y] || s[y]) continue;
        Dfs(y);
    }
}

void DfsT(int x)
{
    p[x] = ctc;
    for (int y = 1; y <= n; ++y)
    {
        if (!a[y][x] || p[y]) continue;
        DfsT(y);
    }
}



void CitesteGraf()
{
    fin >> n >> m;
    int x, y;
    while (m--)
    {
        fin >> x >> y;
        a[x][y] = true;
    }
}
